Index: uspace/srv/net/il/ip/ip.c
===================================================================
--- uspace/srv/net/il/ip/ip.c	(revision 9414abc19106996bac61d12354e75953aa14bf29)
+++ uspace/srv/net/il/ip/ip.c	(revision 32efd865176bfa9c946bb85353ec87e270ab1dda)
@@ -588,23 +478,42 @@
 		ip_globals.gateway.netif = ip_netif;
 	}
+
 	return EOK;
 }
 
-int ip_mtu_changed_message(device_id_t device_id, size_t mtu){
+/** Updates the device content length according to the new MTU value.
+ *
+ * @param[in] device_id	The device identifier.
+ * @param[in] mtu	The new mtu value.
+ * @returns		EOK on success.
+ * @returns		ENOENT if device is not found.
+ */
+static int ip_mtu_changed_message(device_id_t device_id, size_t mtu)
+{
 	ip_netif_ref netif;
 
 	fibril_rwlock_write_lock(&ip_globals.netifs_lock);
 	netif = ip_netifs_find(&ip_globals.netifs, device_id);
-	if(! netif){
+	if (!netif) {
 		fibril_rwlock_write_unlock(&ip_globals.netifs_lock);
 		return ENOENT;
 	}
 	netif->packet_dimension.content = mtu;
+	fibril_rwlock_write_unlock(&ip_globals.netifs_lock);
+
 	printf("%s: Device %d changed MTU to %d\n", NAME, device_id, mtu);
-	fibril_rwlock_write_unlock(&ip_globals.netifs_lock);
+
 	return EOK;
 }
 
-int ip_device_state_message(device_id_t device_id, device_state_t state){
+/** Updates the device state.
+ *
+ * @param[in] device_id	The device identifier.
+ * @param[in] state	The new state value.
+ * @returns		EOK on success.
+ * @returns		ENOENT if device is not found.
+ */
+static int ip_device_state_message(device_id_t device_id, device_state_t state)
+{
 	ip_netif_ref netif;
 
@@ -612,204 +521,108 @@
 	// find the device
 	netif = ip_netifs_find(&ip_globals.netifs, device_id);
-	if(! netif){
+	if (!netif) {
 		fibril_rwlock_write_unlock(&ip_globals.netifs_lock);
 		return ENOENT;
 	}
 	netif->state = state;
+	fibril_rwlock_write_unlock(&ip_globals.netifs_lock);
+
 	printf("%s: Device %d changed state to %d\n", NAME, device_id, state);
-	fibril_rwlock_write_unlock(&ip_globals.netifs_lock);
+
 	return EOK;
 }
 
-int ip_register(int protocol, services_t service, int phone, tl_received_msg_t received_msg){
-	ip_proto_ref proto;
-	int index;
-
-	if(!(protocol && service && ((phone > 0) || (received_msg)))){
-		return EINVAL;
-	}
-	proto = (ip_proto_ref) malloc(sizeof(ip_protos_t));
-	if(! proto){
-		return ENOMEM;
-	}
-	proto->protocol = protocol;
-	proto->service = service;
-	proto->phone = phone;
-	proto->received_msg = received_msg;
-	fibril_rwlock_write_lock(&ip_globals.protos_lock);
-	index = ip_protos_add(&ip_globals.protos, proto->protocol, proto);
-	if(index < 0){
-		fibril_rwlock_write_unlock(&ip_globals.protos_lock);
-		free(proto);
-		return index;
-	}
-	
-	printf("%s: Protocol registered (protocol: %d, phone: %d)\n",
-	    NAME, proto->protocol, proto->phone);
-	
-	fibril_rwlock_write_unlock(&ip_globals.protos_lock);
-	return EOK;
-}
-
-int ip_send_msg_local(int il_phone, device_id_t device_id, packet_t packet, services_t sender, services_t error){
-	ERROR_DECLARE;
-
-	int addrlen;
-	ip_netif_ref netif;
-	ip_route_ref route;
-	struct sockaddr * addr;
-	struct sockaddr_in * address_in;
-//	struct sockaddr_in6 *	address_in6;
-	in_addr_t * dest;
-	in_addr_t * src;
-	int phone;
-
-	// addresses in the host byte order
-	// should be the next hop address or the target destination address
-	addrlen = packet_get_addr(packet, NULL, (uint8_t **) &addr);
-	if(addrlen < 0){
-		return ip_release_and_return(packet, addrlen);
-	}
-	if((size_t) addrlen < sizeof(struct sockaddr)){
-		return ip_release_and_return(packet, EINVAL);
-	}
-	switch(addr->sa_family){
-		case AF_INET:
-			if(addrlen != sizeof(struct sockaddr_in)){
-				return ip_release_and_return(packet, EINVAL);
+
+/** Prefixes a middle fragment header based on the last fragment header to the
+ * packet.
+ *
+ * @param[in] packet	The packet to be prefixed.
+ * @param[in] last	The last header to be copied.
+ * @returns		The prefixed middle header.
+ * @returns		NULL on error.
+ */
+static ip_header_ref
+ip_create_middle_header(packet_t packet, ip_header_ref last)
+{
+	ip_header_ref middle;
+
+	middle = (ip_header_ref) packet_suffix(packet, IP_HEADER_LENGTH(last));
+	if (!middle)
+		return NULL;
+	memcpy(middle, last, IP_HEADER_LENGTH(last));
+	middle->flags |= IPFLAG_MORE_FRAGMENTS;
+	return middle;
+}
+
+/** Copies the fragment header.
+ *
+ * Copies only the header itself and relevant IP options.
+ *
+ * @param[out] last	The created header.
+ * @param[in] first	The original header to be copied.
+ */
+static void ip_create_last_header(ip_header_ref last, ip_header_ref first)
+{
+	ip_option_ref option;
+	size_t next;
+	size_t length;
+
+	// copy first itself
+	memcpy(last, first, sizeof(ip_header_t));
+	length = sizeof(ip_header_t);
+	next = sizeof(ip_header_t);
+
+	// process all ip options
+	while (next < first->header_length) {
+		option = (ip_option_ref) (((uint8_t *) first) + next);
+		// skip end or noop
+		if ((option->type == IPOPT_END) ||
+		    (option->type == IPOPT_NOOP)) {
+			next++;
+		} else {
+			// copy if told so or skip
+			if (IPOPT_COPIED(option->type)) {
+				memcpy(((uint8_t *) last) + length,
+				    ((uint8_t *) first) + next, option->length);
+				length += option->length;
 			}
-			address_in = (struct sockaddr_in *) addr;
-			dest = &address_in->sin_addr;
-			if(! dest->s_addr){
-				dest->s_addr = IPV4_LOCALHOST_ADDRESS;
-			}
-			break;
-		// TODO IPv6
-/*		case AF_INET6:
-			if(addrlen != sizeof(struct sockaddr_in6)){
-				return EINVAL;
-			}
-			address_in6 = (struct sockaddr_in6 *) dest;
-			address_in6.sin6_addr.s6_addr;
-			IPV6_LOCALHOST_ADDRESS;
-*/		default:
-			return ip_release_and_return(packet, EAFNOSUPPORT);
-	}
-	netif = NULL;
-	route = NULL;
-	fibril_rwlock_read_lock(&ip_globals.netifs_lock);
-	// device specified?
-	if(device_id > 0){
-		netif = ip_netifs_find(&ip_globals.netifs, device_id);
-		route = ip_netif_find_route(netif, * dest);
-		if(netif && (! route) && (ip_globals.gateway.netif == netif)){
-			route = &ip_globals.gateway;
-		}
-	}
-	if(! route){
-		route = ip_find_route(*dest);
-		netif = route ? route->netif : NULL;
-	}
-	if(!(netif && route)){
-		fibril_rwlock_read_unlock(&ip_globals.netifs_lock);
-		phone = ip_prepare_icmp_and_get_phone(error, packet, NULL);
-		if(phone >= 0){
-			// unreachable ICMP if no routing
-			icmp_destination_unreachable_msg(phone, ICMP_NET_UNREACH, 0, packet);
-		}
-		return ENOENT;
-	}
-	if(error){
-		// do not send for broadcast, anycast packets or network broadcast
-		if((! dest->s_addr)
-			|| (!(~ dest->s_addr))
-			|| (!(~((dest->s_addr &(~ route->netmask.s_addr)) | route->netmask.s_addr)))
-			|| (!(dest->s_addr &(~ route->netmask.s_addr)))){
-			return ip_release_and_return(packet, EINVAL);
-		}
-	}
-	// if the local host is the destination
-	if((route->address.s_addr == dest->s_addr)
-		&& (dest->s_addr != IPV4_LOCALHOST_ADDRESS)){
-		// find the loopback device to deliver
-		dest->s_addr = IPV4_LOCALHOST_ADDRESS;
-		route = ip_find_route(*dest);
-		netif = route ? route->netif : NULL;
-		if(!(netif && route)){
-			fibril_rwlock_read_unlock(&ip_globals.netifs_lock);
-			phone = ip_prepare_icmp_and_get_phone(error, packet, NULL);
-			if(phone >= 0){
-				// unreachable ICMP if no routing
-				icmp_destination_unreachable_msg(phone, ICMP_HOST_UNREACH, 0, packet);
-			}
-			return ENOENT;
-		}
-	}
-	src = ip_netif_address(netif);
-	if(! src){
-		fibril_rwlock_read_unlock(&ip_globals.netifs_lock);
-		return ip_release_and_return(packet, ENOENT);
-	}
-	ERROR_CODE = ip_send_route(packet, netif, route, src, * dest, error);
-	fibril_rwlock_read_unlock(&ip_globals.netifs_lock);
-	return ERROR_CODE;
-}
-
-in_addr_t * ip_netif_address(ip_netif_ref netif){
-	ip_route_ref route;
-
-	route = ip_routes_get_index(&netif->routes, 0);
-	return route ? &route->address : NULL;
-}
-
-int ip_send_route(packet_t packet, ip_netif_ref netif, ip_route_ref route, in_addr_t * src, in_addr_t dest, services_t error){
-	ERROR_DECLARE;
-
-	measured_string_t destination;
-	measured_string_ref translation;
-	char * data;
-	int phone;
-
-	// get destination hardware address
-	if(netif->arp && (route->address.s_addr != dest.s_addr)){
-		destination.value = route->gateway.s_addr ? (char *) &route->gateway.s_addr : (char *) &dest.s_addr;
-		destination.length = CONVERT_SIZE(dest.s_addr, char, 1);
-		if(ERROR_OCCURRED(arp_translate_req(netif->arp->phone, netif->device_id, SERVICE_IP, &destination, &translation, &data))){
-//			sleep(1);
-//			ERROR_PROPAGATE(arp_translate_req(netif->arp->phone, netif->device_id, SERVICE_IP, &destination, &translation, &data));
-			pq_release_remote(ip_globals.net_phone, packet_get_id(packet));
-			return ERROR_CODE;
-		}
-		if(!(translation && translation->value)){
-			if(translation){
-				free(translation);
-				free(data);
-			}
-			phone = ip_prepare_icmp_and_get_phone(error, packet, NULL);
-			if(phone >= 0){
-				// unreachable ICMP if no routing
-				icmp_destination_unreachable_msg(phone, ICMP_HOST_UNREACH, 0, packet);
-			}
-			return EINVAL;
-		}
-	}else translation = NULL;
-	if(ERROR_OCCURRED(ip_prepare_packet(src, dest, packet, translation))){
-		pq_release_remote(ip_globals.net_phone, packet_get_id(packet));
-	}else{
-		packet = ip_split_packet(packet, netif->packet_dimension.prefix, netif->packet_dimension.content, netif->packet_dimension.suffix, netif->packet_dimension.addr_len, error);
-		if(packet){
-			nil_send_msg(netif->phone, netif->device_id, packet, SERVICE_IP);
-		}
-	}
-	if(translation){
-		free(translation);
-		free(data);
-	}
-	return ERROR_CODE;
-}
-
-int ip_prepare_packet(in_addr_t * source, in_addr_t dest, packet_t packet, measured_string_ref destination){
-	ERROR_DECLARE;
-
+			// next option
+			next += option->length;
+		}
+	}
+
+	// align 4 byte boundary
+	if (length % 4) {
+		bzero(((uint8_t *) last) + length, 4 - (length % 4));
+		last->header_length = length / 4 + 1;
+	} else {
+		last->header_length = length / 4;
+	}
+
+	last->header_checksum = 0;
+}
+
+/** Prepares the outgoing packet or the packet queue.
+ *
+ * The packet queue is a fragmented packet
+ * Updates the first packet's IP header.
+ * Prefixes the additional packets with fragment headers.
+ *
+ * @param[in] source	The source address.
+ * @param[in] dest	The destination address.
+ * @param[in,out] packet The packet to be sent.
+ * @param[in] destination The destination hardware address.
+ * @returns		EOK on success.
+ * @returns		EINVAL if the packet is too small to contain the IP
+ *			header.
+ * @returns		EINVAL if the packet is too long than the IP allows.
+ * @returns		ENOMEM if there is not enough memory left.
+ * @returns		Other error codes as defined for the packet_set_addr()
+ *			function.
+ */
+static int
+ip_prepare_packet(in_addr_t *source, in_addr_t dest, packet_t packet,
+    measured_string_ref destination)
+{
 	size_t length;
 	ip_header_ref header;
@@ -817,63 +630,97 @@
 	ip_header_ref middle_header;
 	packet_t next;
+	int rc;
 
 	length = packet_get_data_length(packet);
-	if((length < sizeof(ip_header_t)) || (length > IP_MAX_CONTENT)){
+	if ((length < sizeof(ip_header_t)) || (length > IP_MAX_CONTENT))
 		return EINVAL;
-	}
+
 	header = (ip_header_ref) packet_get_data(packet);
-	if(destination){
-		ERROR_PROPAGATE(packet_set_addr(packet, NULL, (uint8_t *) destination->value, CONVERT_SIZE(char, uint8_t, destination->length)));
-	}else{
-		ERROR_PROPAGATE(packet_set_addr(packet, NULL, NULL, 0));
-	}
+	if (destination) {
+		rc = packet_set_addr(packet, NULL, (uint8_t *) destination->value,
+		    CONVERT_SIZE(char, uint8_t, destination->length));
+	} else {
+		rc = packet_set_addr(packet, NULL, NULL, 0);
+	}
+	if (rc != EOK)
+		return rc;
+	
 	header->version = IPV4;
 	header->fragment_offset_high = 0;
 	header->fragment_offset_low = 0;
 	header->header_checksum = 0;
-	if(source){
+	if (source)
 		header->source_address = source->s_addr;
-	}
 	header->destination_address = dest.s_addr;
+
 	fibril_rwlock_write_lock(&ip_globals.lock);
-	++ ip_globals.packet_counter;
+	ip_globals.packet_counter++;
 	header->identification = htons(ip_globals.packet_counter);
 	fibril_rwlock_write_unlock(&ip_globals.lock);
-//	length = packet_get_data_length(packet);
-	if(pq_next(packet)){
+
+	if (pq_next(packet)) {
 		last_header = (ip_header_ref) malloc(IP_HEADER_LENGTH(header));
-		if(! last_header){
+		if (!last_header)
 			return ENOMEM;
-		}
 		ip_create_last_header(last_header, header);
 		next = pq_next(packet);
-		while(pq_next(next)){
-			middle_header = (ip_header_ref) packet_prefix(next, IP_HEADER_LENGTH(last_header));
-			if(! middle_header){
+		while (pq_next(next)) {
+			middle_header = (ip_header_ref) packet_prefix(next,
+			    IP_HEADER_LENGTH(last_header));
+			if (!middle_header) {
+				free(last_header);
 				return ENOMEM;
 			}
-			memcpy(middle_header, last_header, IP_HEADER_LENGTH(last_header));
+
+			memcpy(middle_header, last_header,
+			    IP_HEADER_LENGTH(last_header));
 			header->flags |= IPFLAG_MORE_FRAGMENTS;
-			middle_header->total_length = htons(packet_get_data_length(next));
-			middle_header->fragment_offset_high = IP_COMPUTE_FRAGMENT_OFFSET_HIGH(length);
-			middle_header->fragment_offset_low = IP_COMPUTE_FRAGMENT_OFFSET_LOW(length);
-			middle_header->header_checksum = IP_HEADER_CHECKSUM(middle_header);
-			if(destination){
-				ERROR_PROPAGATE(packet_set_addr(next, NULL, (uint8_t *) destination->value, CONVERT_SIZE(char, uint8_t, destination->length)));
+			middle_header->total_length =
+			    htons(packet_get_data_length(next));
+			middle_header->fragment_offset_high =
+			    IP_COMPUTE_FRAGMENT_OFFSET_HIGH(length);
+			middle_header->fragment_offset_low =
+			    IP_COMPUTE_FRAGMENT_OFFSET_LOW(length);
+			middle_header->header_checksum =
+			    IP_HEADER_CHECKSUM(middle_header);
+			if (destination) {
+				rc = packet_set_addr(next, NULL,
+				    (uint8_t *) destination->value,
+				    CONVERT_SIZE(char, uint8_t,
+				    destination->length));
+				if (rc != EOK) {
+				    	free(last_header);
+					return rc;
+				}
 			}
 			length += packet_get_data_length(next);
 			next = pq_next(next);
 		}
-		middle_header = (ip_header_ref) packet_prefix(next, IP_HEADER_LENGTH(last_header));
-		if(! middle_header){
+
+		middle_header = (ip_header_ref) packet_prefix(next,
+		    IP_HEADER_LENGTH(last_header));
+		if (!middle_header) {
+			free(last_header);
 			return ENOMEM;
 		}
-		memcpy(middle_header, last_header, IP_HEADER_LENGTH(last_header));
-		middle_header->total_length = htons(packet_get_data_length(next));
-		middle_header->fragment_offset_high = IP_COMPUTE_FRAGMENT_OFFSET_HIGH(length);
-		middle_header->fragment_offset_low = IP_COMPUTE_FRAGMENT_OFFSET_LOW(length);
-		middle_header->header_checksum = IP_HEADER_CHECKSUM(middle_header);
-		if(destination){
-			ERROR_PROPAGATE(packet_set_addr(next, NULL, (uint8_t *) destination->value, CONVERT_SIZE(char, uint8_t, destination->length)));
+
+		memcpy(middle_header, last_header,
+		    IP_HEADER_LENGTH(last_header));
+		middle_header->total_length =
+		    htons(packet_get_data_length(next));
+		middle_header->fragment_offset_high =
+		    IP_COMPUTE_FRAGMENT_OFFSET_HIGH(length);
+		middle_header->fragment_offset_low =
+		    IP_COMPUTE_FRAGMENT_OFFSET_LOW(length);
+		middle_header->header_checksum =
+		    IP_HEADER_CHECKSUM(middle_header);
+		if (destination) {
+			rc = packet_set_addr(next, NULL,
+			    (uint8_t *) destination->value,
+			    CONVERT_SIZE(char, uint8_t, destination->length));
+			if (rc != EOK) {
+				free(last_header);
+				return rc;
+			}
 		}
 		length += packet_get_data_length(next);
